<!DOCTYPE html>
<html lang="en">
<head>
    <title>Task 32.50 Load all Users</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container">
        <div class="text-center my-4">
            <h2>Danh sách người dùng đăng ký</h2>
        </div>
        <div class="my-2">
            <a class="btn btn-success" href="insertUser.html">Thêm user</a>
        </div>
        <table class="table table-bordered table-striped table-hover" id="user-table">
            <thead>
              <tr>
                <th>Id</th>
                <th>Firstname</th>
                <th>Lastname</th>
                <th>Country</th>
                <th>Subject</th>
                <th>Customer Type</th>
                <th>Register Status</th>
                <th>Action</th>
              </tr>
            </thead>
            <tbody>
              
            </tbody>
          </table>
    </div>
</body>

<script>
    "use strict";
    //REGION 1

    //REGION 2
    $(document).ready(function(){
        onPageLoading();
    });
    //REGION 3
    //hàm load trang
    function onPageLoading(){
        //gọi api để load dữ liệu vào table
        callApiGetUsers();
    }
    //hàm thực hiện sự kiện nút btn sửa được ấn
    function onBtnSuaClick(paramDetail){
        console.log("nút sửa được ấn");
        var vUserId = $(paramDetail).data("userId");
        console.log("Id: " + vUserId);
        const VUSER_FORM_URL = "UpdateUser.html"
        var vUrlToOpenPage = VUSER_FORM_URL + "?" + "id=" + vUserId;
        window.location.href = vUrlToOpenPage;
    }
    //hàm thực hiện sự kiện nút btn xóa được ấn
    function onBtnXoaClick(paramDetail){
        console.log("Nút xóa được ấn");
        var vUserId = $(paramDetail).data("userId");
        console.log("id: " + vUserId);
        var vResult = confirm("Bạn có chắc chắn muốn xóa không");
        if(vResult == true){
            console.log("UserId: " + vUserId);
            $.ajax({
                url: "http://203.171.20.210:8080/crud-api/users/" + vUserId,
                type: "DELETE",
                dataType: "Json",
                success: function(response){
                    alert("Đã xóa user thành công");
                    location.reload();
                },
                error: function(ajaxContext){
                    console.log(ajaxContext);
                }
            })
        }
    }
    //REGION 4
    //hàm gọi api lấy dữ liệu Users từ server
    function callApiGetUsers(){
        "use strict";
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "GET",
            dataType: "Json",
            success: function(res){
                console.log(res);
                loadDataToTable(res);
            },
            error: function(ajaxContext){
                console.log(ajaxContext.responseText);
            }
        })
    }
    //hàm load data to table
    function loadDataToTable(paramRes){
        //truy xuât table
        var vTable = $("#user-table");
        for(var bI = 0; bI < paramRes.length; bI++){
            //tạo dòng mới
            var bNewRow = $("<tr>").appendTo(vTable);
            //tạo côt mới
            $("<td>", {html: paramRes[bI].id}).appendTo(bNewRow);
            $("<td>", {html: paramRes[bI].firstname}).appendTo(bNewRow);
            $("<td>", {html: paramRes[bI].lastname}).appendTo(bNewRow);
            $("<td>", {html: paramRes[bI].country}).appendTo(bNewRow);
            $("<td>", {html: paramRes[bI].subject}).appendTo(bNewRow);
            $("<td>", {html: paramRes[bI].customerType}).appendTo(bNewRow);
            $("<td>", {html: paramRes[bI].registerStatus}).appendTo(bNewRow);
            //ở action
            var bActionCell = $("<td>").appendTo(bNewRow);
            $("<button>", {
            html: "Sửa",
            class: "btn btn-primary user-detail",
            })
                .click(function(){
                    onBtnSuaClick(this);
                })
                .data("userId", paramRes[bI].id)
                .appendTo(bActionCell);

            $("<button>", {
            html: "Xóa",
            class: "btn btn-danger user-delete",
            })
                .click(function(){
                    onBtnXoaClick(this);
                })
                .data("userId", paramRes[bI].id)
                .appendTo(bActionCell);
        }
    }

</script>
</html>